diff --git a/subsys/net/ip/tcp.c b/subsys/net/ip/tcp.c
index 00d4f762d2cc00..4f26ff40cdcaf2 100644
--- a/subsys/net/ip/tcp.c
+++ b/subsys/net/ip/tcp.c
@@ -2338,7 +2338,7 @@ NET_CONN_CB(tcp_syn_rcvd)
 	/*
 	 * If we receive ACK, we go to ESTABLISHED state.
 	 */
-	if (NET_TCP_FLAGS(tcp_hdr) == NET_TCP_ACK) {
+	if (NET_TCP_FLAGS(tcp_hdr) & NET_TCP_ACK) {
 		struct net_context *new_context;
 		socklen_t addrlen;
 		int ret;
